package polyglot.ext.ejava.ast;

import polyglot.ast.*;
import polyglot.ext.ejava.types.ExtensionType;
import polyglot.ext.jl.ast.JL_c;
import polyglot.types.FieldInstance;
import polyglot.util.CodeWriter;
import polyglot.visit.PrettyPrinter;

public class EJavaField_Del extends JL_c implements JL {

    @Override
    public void prettyPrint(CodeWriter w, PrettyPrinter pp) {
        Field f = (Field) node();
        Receiver target = f.target();
        if (!f.isTargetImplicit()) {
            // explicit target.
            if (target instanceof Expr) {
                f.printSubExpr((Expr) target, w, pp);
            } else if (target instanceof TypeNode || target instanceof AmbReceiver) {
                pp.print(f, target, w);
            }

            w.write(".");
        }
        FieldInstance fi = (FieldInstance) f.fieldInstance();
        if (fi.container() instanceof ExtensionType) {
            w.write("state.");
        }
        w.write(f.name());
    }

}
