package polyglot.ext.ejava.ast;

import polyglot.ast.JL;
import polyglot.ast.Node;
import polyglot.ast.Special;
import polyglot.ext.ejava.types.ExtensionType;
import polyglot.ext.jl.ast.JL_c;
import polyglot.types.ClassType;
import polyglot.types.SemanticException;
import polyglot.visit.TypeChecker;

public class EJavaSpecial_Del extends JL_c implements JL {

    @Override
    public Node typeCheck(TypeChecker tc) throws SemanticException {
        Special spec = (Special) node();
        spec = (Special) spec.typeCheck(tc);
        ClassType ct = tc.context().currentClass();
        if (ct instanceof ExtensionType) {
            ExtensionType et = (ExtensionType) ct;
            if (spec.kind() == Special.THIS)
                spec = (Special) spec.type(et.superType());
            else if (spec.kind() == Special.SUPER)
                spec = (Special) spec.type(et);
        }
        return spec;
    }

}
