package polyglot.ext.ejava.ast;

import polyglot.ast.Node;
import polyglot.ext.ejava.types.EJavaContext;
import polyglot.ext.ejava.types.ExtensionType;
import polyglot.ext.jl.ast.Import_c;
import polyglot.types.Named;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;

public class UseExpander_c extends Import_c implements UseExpander {

    public UseExpander_c(Position pos, Kind kind, String name) {
        super(pos, kind, name);
    }

    @Override
    public Node typeCheck(TypeChecker tc) throws SemanticException {
        super.typeCheck(tc);
//        if (kind == EXPANDER) {
            Named nt = tc.typeSystem().forName(name);
            if (nt instanceof ExtensionType) {
                ExtensionType et = (ExtensionType) nt;
                ((EJavaContext)tc.context()).addExtension(et);
            }
            else {
                throw new SemanticException("Only expanders can be \"use\"d.", this.position());
            }
//        }
        return this;
    }

    
    
}
