package polyglot.ext.ejava.types;

import java.util.List;

import polyglot.ast.Expr;
import polyglot.ext.jl5.types.JL5TypeSystem;
import polyglot.frontend.Source;
import polyglot.types.*;
import polyglot.util.Position;

public interface EJavaTypeSystem extends JL5TypeSystem {
    public ExtensionType createExtensionType(LazyClassInitializer init, Source fromSource);

    public MethodInstance extensionFriendlyFindMethod(ReferenceType container, String name,
            List argTypes, EJavaContext context) throws SemanticException;

    public ConstructorInstance extensionFriendlyFindConstructor(ClassType container, List argTypes,
            EJavaContext c) throws SemanticException;

    public ExtensionType findExtension(ClassType from, ClassType to, EJavaContext context,
            Position pos) throws SemanticException;

    public Expr applyExtensions(Expr e, Type to, EJavaContext context) throws SemanticException;

    public UnextendedType UnextendedType(ClassType t);
    
    public EJavaContext getCurrentContext();
    public void setCurrentContext(EJavaContext ctx);
    
    public void setUseExpanders(boolean useExpanders);
    public boolean getUseExpanders();
    
}
